LeetCode 1. Two Sum (C++)

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

翻译

给定一个整数数组,返回两个数字的下标,使它们加起来等于一个特定的值。
确保每个输入仅有一个答案,并且不能两次使用同一元素。

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

分析

可以用hash table来做,写一个Map,键表示数字,值表示下标。
另外由于 may not use the same element twice. 的限制,给hash map赋值需要延后,是个很巧妙的做法。
这样保证了每次运行到if(hash.count(Tofindnumber))条件语句时,不会和自己做比较(因为赋值延后了,此时自身的hash map还没赋值)。解决了不能同时运用1个元素2次的问题 !

AC代码

class Solution {
	public:
		vector<int> twoSum(vector<int> & nums,int target ){
			vector<int > v;
			unordered_map<int ,int> hash;//unordered_map比map运算时间更短
			int Tofindnumber;
			for(int i=0;i< nums.size();i++)
			{
				Tofindnumber = target - nums[i];//要找的数字
				if(hash.count(Tofindnumber))//如果找到了
				{
					v.push_back( i );//下标压入vector
					v.push_back( hash[Tofindnumber] );//第2个下标也压入vector,然后返回数组
					break;
				}
				else
				{
					hash[ nums[i] ] = i; 
				}
			}
		return v;
		}
};

C++ 二刷

class Solution {
public:
    vector<int> twoSum(vector<int>& nums, int target) {
        vector<int> v;
        unordered_map<int, int> hash;
        for(int i = 0; i < nums.size(); i++){
            hash[ nums[i] ] = i;
        }
        for(int i = 0; i < nums.size(); i++){
           int tfn = target - nums[i];
           if(hash.count(tfn) && i != hash[tfn]){
               return {i, hash[tfn]};
           }
        }
        return v;
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值